Public Class Form1
    Private Const pipeName As String = "\\.\pipe\MyPipe"
    Private Const BUFFSIZE As Integer = 10000
    Private ClientPipe As Integer

    Public Const INVALID_HANDLE_VALUE As Short = -1
    Public Declare Function CallNamedPipe Lib "kernel32" Alias "CallNamedPipeA" _
    ( _
        ByVal lpNamedPipeName As String, _
        ByRef lpInBuffer As Byte, _
        ByVal nInBufferSize As Integer, _
        ByRef lpOutBuffer As Byte, _
        ByVal nOutBufferSize As Integer, _
        ByRef lpBytesRead As Integer, _
        ByVal nTimeOut As Integer _
    ) As Integer

    'Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    '    Dim BytesWritten As Integer
    '    Dim Buffer(BUFFSIZE), InputBuffer(BUFFSIZE) As Byte
    '    Dim InputString As String = ""

    '    'Fill the write buffer with increasing numbers.
    '    For i As Integer = 0 To Buffer.Length - 1
    '        Buffer(i) = CByte(i Mod 256)
    '    Next

    '    'Create the pipe for reading and writing.
    '    ClientPipe = CreateFile(pipeName, GENERIC_WRITE Or GENERIC_READ, 0, Nothing, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, Nothing)

    '    'Check to make sure pipe was created successfully
    '    If ClientPipe = INVALID_HANDLE_VALUE Then
    '        MsgBox("Could not create named pipe.")
    '        Exit Sub
    '    End If

    '    'Write to the pipe
    '    If WriteFile(ClientPipe, Buffer, BUFFSIZE, BytesWritten, 0) = 0 Then
    '        MsgBox("Could not write to pipe.")
    '        DisconnectNamedPipe(ClientPipe)
    '        Exit Sub
    '    End If

    '    'Read from the pipe
    '    If ReadFile(ClientPipe, InputBuffer, BUFFSIZE, BytesWritten, 0) = 0 Then
    '        MsgBox("Could not read from pipe.")
    '        DisconnectNamedPipe(ClientPipe)
    '        Exit Sub
    '    End If

    '    'Display what was read from the pipe
    '    For i As Integer = 0 To InputBuffer.Length - 1
    '        InputString = InputString & Format(InputBuffer(i), "000 ")
    '    Next
    '    TextBox2.Text = InputString

    '    Label1.Text = "Read/Write completed"
    'End Sub


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim BytesRead As Integer
        Dim Buffer(BUFFSIZE), Message(BUFFSIZE) As Byte
        Dim InputString As String

        'Fill the buffer with numbers
        For i As Integer = 0 To 12
            Message(i) = CByte((i + 5) Mod 256)
        Next i

        'Send message along pipe and wait for response.
        If CallNamedPipe(pipeName, Message(0), 12, Buffer(0), BUFFSIZE, BytesRead, 30000) = 0 Then
            'If the pipe is broken...
            Label1.Text = "Error calling named pipe."
            Exit Sub
        End If

        'Display the bytes retrieved from pipe.
        InputString = Format(Buffer(0), "000")
        For i As Integer = 1 To BytesRead - 1
            InputString = InputString & " " & Format(Buffer(i), "000")
        Next i
        TextBox2.Text = InputString
    End Sub
End Class

Module Comm_Pipes
    'Copied from Help.
    Public Const GENERIC_READ As Int32 = &H80000000
    Public Const GENERIC_WRITE As Int32 = &H40000000
    Public Const OPEN_EXISTING As Int32 = 3
    Public Const NOPARITY As Int32 = 0
    Public Const ONESTOPBIT As Int32 = 0

    'Code copied from MSDN Library.
    Public Const FILE_ATTRIBUTE_NORMAL As Short = &H80S
    Public Const FILE_FLAG_NO_BUFFERING As Integer = &H20000000
    Public Const FILE_FLAG_WRITE_THROUGH As Integer = &H80000000

    Public Const PIPE_ACCESS_DUPLEX As Short = &H3S
    Public Const PIPE_READMODE_MESSAGE As Short = &H2S
    Public Const PIPE_TYPE_MESSAGE As Short = &H4S
    Public Const PIPE_WAIT As Short = &H0S

    Public Const INVALID_HANDLE_VALUE As Short = -1

    Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
   (ByVal lpFileName As String, ByVal dwDesiredAccess As Int32, _
      ByVal dwShareMode As Int32, ByVal lpSecurityAttributes As IntPtr, _
         ByVal dwCreationDisposition As Int32, ByVal dwFlagsAndAttributes As Int32, _
            ByVal hTemplateFile As IntPtr) As IntPtr

    Declare Function CreateNamedPipe Lib "kernel32" Alias "CreateNamedPipeA" _
    (ByVal lpName As String, ByVal dwOpenMode As Integer, _
    ByVal dwPipeMode As Integer, ByVal nMaxInstances As Integer, _
    ByVal nOutBufferSize As Integer, ByVal nInBufferSize As Integer, _
    ByVal nDefaultTimeOut As Integer, ByVal lpSecurityAttributes As IntPtr _
    ) As Integer

    Declare Function ConnectNamedPipe Lib "kernel32" _
        (ByVal hNamedPipe As Integer, ByVal lpOverlapped As Integer) As Integer

    Declare Function DisconnectNamedPipe Lib "kernel32" _
        (ByVal hNamedPipe As Integer) As Integer

    Declare Function WriteFile Lib "kernel32" _
    ( _
        ByVal hFile As Integer, _
        ByRef lpBuffer() As Byte, _
        ByVal nNumberOfBytesToWrite As Integer, _
        ByRef lpNumberOfBytesWritten As Integer, _
        ByVal lpOverlapped As Integer _
    ) As Integer
    'Notes from "Win32 System Services: The Heart of Windows 95 & Windows NT", Second Edition (p54) about WriteFile:
    '
    'hFile - Hanlde to a file created by CreateFile
    'lpBuffer - Data to write
    'nNumberOfBytesToWrite - The number of bytes to write
    'lpNumberOfBytesWritten - The number of bytes actually written
    'lpOverlapped - Overlapped structure


    Declare Function ReadFile Lib "kernel32" _
    ( _
        ByVal hFile As Integer, _
        ByRef lpBuffer() As Byte, _
        ByVal nNumberOfBytesToRead As Integer, _
        ByRef lpNumberOfBytesRead As Integer, _
        ByVal lpOverlapped As Integer _
    ) As Integer
    'Notes from "Win32 System Services: The Heart of Windows 95 & Windows NT", Second Edition (p32) about ReadFile:
    '
    'hFile - File handle created with CreateFile
    'lpBuffer - Buffer to hold the read bytes.
    'nNumberOfBytesToRead - The number of bytes desired
    'lpNumberOfBytesRead - The number of bytes actually placed in the buffer
    'lpOverlapped - Pointer to overlapped structure

    Declare Function FlushFileBuffers Lib "kernel32" _
        (ByVal hFile As Integer) As Integer

    Declare Function CloseHandle Lib "kernel32" _
        (ByVal hObject As Integer) As Integer
End Module